\documentclass{article}
\usepackage{amsmath,amssymb,bm}
\bibliographystyle{IEEEtran}
\renewcommand{\baselinestretch}{1.5}
\textheight 225mm
\topskip 0mm
\headheight 0mm
\headsep 0mm
\textwidth 150mm
\oddsidemargin 9mm
\topmargin 4mm
\parindent 5ex
\parskip 0mm
\newcommand{\en}{\enspace}
\newcommand{\mm}{\phantom{$-$}}
\newcommand{\eol}{\\ \noindent}
\newcommand{\bo}[4]{
\stackrel{{\scriptscriptstyle #2}}{#1}
\raisebox{-0.ex}{\hspace*{-0.3em}$^{#3}$}
\raisebox{-0.1ex}{\hspace*{-0.6em}$_{#4}$}\hspace*{0.1em}
}
\makeindex
\begin{document}
\title{
autoPES Package \\
{\sf User's Guide} \\
{\normalsize Version 1.0} \\[10mm]
}

\author{{\bf Michael P. Metz, Konrad Piszczatowski, and Krzysztof Szalewicz}\\[9mm]
Department of Physics and Astronomy, \\[-2mm]
University of Delaware, Newark, Delaware 19716 \vspace{3 mm} \\
}
\maketitle

\newpage

\tableofcontents

\newpage

\section{Introduction}
The autoPES package automates the development of accurate symmetry-adapted perturbation (SAPT) based intermoleular potential energy surfaces (PES), also known as force-fields, of rigid molecules. It is also possible to use the coupled cluster method with single, double, and noniterative triple excitations [CCSD(T)] to compute interaction energies instead of SAPT. It is an implementation of the methodology described in Ref.~\cite{Metz:16}. The current version autoPES can generate potentials using SAPT based on density functional theory [SAPT(DFT)] \cite{Misquitta:05a,Misquitta:05b} or CCSD(T). The PES generation procedure can be broadly divided into six steps:
\begin{enumerate}
\item Grid point generation -- The generation of a set of dimer configurations which adequately represent the most important regions of intermolecular interaction.
\item {\em Ab initio} calculations -- Computing interaction energies at each of the generated grid points.
\item Asymptotic calculations -- The potentials generated by the autoPES package seamlessly integrate long-range and short-range interactions. The long-range components of the PES require separate {\em ab intio} calculations, which are done in this step.
\item Parameterization -- The data from the {\em ab initio} calculations at grid points and the asymptotic calculations are combined, and the parameters of the PES are optimized.
\item Hole fixing -- Due to the functional form of the fit, it is possible that the PES lacks a physically accurate repulsive wall at short-range dimer configurations. This step automatically corrects these `holes' by performing additional {\em ab initio} calculations as necessary.
\item Iterative improvement -- Based on the results of the parameterization step, the autoPES package automatically determines if any additional grid points are required, and if so performs the additional calculations and fits.
\end{enumerate}
The autoPES package does not itself perform {\em ab initio} calculations, but rather interfaces with the SAPT package \cite{SAPT2016}. The SAPT package in turn interfaces with external front-end programs to perform monomer {\em ab initio} calculations.  In addition, the autoPES package interfaces directly with these front-end programs to perform certain steps of the PES generation. The current version of autoPES requires both Orca \cite{ORCA} and Dalton \cite{Dalton} to run, in addition to the SAPT package. 

\section{Installation}
Installation of autoPES requires the following steps:
\begin{enumerate}
\item The following software must first be installed on the system:
\begin{itemize}
\item Orca 3.0.1 \cite{ORCA}
\item Dalton 2.0 \cite{Dalton}
\item SAPT2016 \cite{SAPT2016}
\end{itemize}

Note that Dalton 2.0 must be patched using the script included in the SAPT package in order to use GRAC asymptotic correction, see the SAPT manual.

It is recommended that the SAPT installation be tested with both ORCA and Dalton interfaces using the included examples before attempting to use autoPES.

\item To compile autoPES, first edit the {\tt \$PATH/compall} script and set the variables BLAS, TARGET, and OMP. Here {\tt \$PATH} is the autoPES installation directory, which is extracted from the archive file available on the web.
\begin{itemize}
\item TARGET specifies the FORTRAN 2003 compatible compiler to use. The autoPES package has been tested with the Intel ifort version 14.0 and GNU gfortran version 4.8.1 compilers.
\item BLAS is a string of compiler arguments specifying an appropriate Basic Linear Algebra Subprograms library. This BLAS should be configured to run in a serial (single-threaded) mode, and its performance is not crucial to the overall performance of PES generation.
\item OMP specifies whether autoPES will be compiled with OpenMP parallelization enabled. See Sec.~\ref{subsec:par} for details. OMP should be set to either `YES' or `NO'.
\end{itemize}
 After these variables are specified, simply run the {\tt compall} script from the autoPES root directory. The {\tt clean} script may be used to remove compiled files in order to perform a clean installation.

\item The file {\tt \$PATH/bin/vars} contains paths to the installations of Orca and SAPT installed on the system. These variables must be set manually before running autoPES.

\item Finally, the file {\tt \$PATH/bin/submit.sh} must be modified to interface with the job submission system present on the specific computer system. This script must ensure that the specified resources are available, copy the specified input files to an appropriate scratch directory, perform the specified work, and finally copy the specified output files back. Details of each step are given in the comments of the provided example {\tt submit.sh.EXAMPLE} file.

On most large computer systems, running a job requires one to create a job script, then submit it to a queuing system with a command such as {\tt qsub}. Because of the complexity and large computational cost of PES generation, it is often undesirable to use autoPES directly in this way. Rather, the {\tt submit.sh} file dynamically creates the job scripts, and autoPES submits multiple jobs as necessary.

To perform this step of installation, the user should first ensure that he/she knows how to properly run jobs on the given computer system. The {\tt \$PATH/bin/submit.sh.EXAMPLE} file should then be copied to {\tt \$PATH/bin/submit.sh}, and the latter file should be modified to run the required jobs in a way appropriate for the system. In addition to performing the required work, the {\tt submit.sh} file must create appropriate `marker' files in order for autoPES to know when a job has started or completed running. Additionally, depending on the computer system, the {\tt submit.sh} file may need to transfer files to an appropriate scratch directory and/or provide commands to the queuing system specifying required resources. These steps are outlined and described in the comments of the provided {\tt submit.sh.EXAMPLE} file. 

The {\tt submit.sh} file may also be configured to run jobs directly, rather than submitting to a queuing system. This may be useful for generating potentials on a workstation or other small computer system, but this is only recommended for small dimers.
\end{enumerate}

\section{Basic usage}\label{sec:usage}
The autoPES program requires two input files. The first, {\tt NAME.input}, specifies the molecular structure of each monomer. The second, {\tt NAME.ctrl}, specifies various options of the desired PES and computation control parameters. Here NAME is the name of the system, and can be any string up to 20 characters long.

\subsection{Control file}\label{subsec:ctrl}
The {\tt NAME.ctrl} file should be prepared in the standard FORTRAN name-list format. The simplest {\tt NAME.ctrl} file would look like

\begin{verbatim}
&GENERAL
/
&AB_INITIO
/
&GRID_GENERATION
/
&ASYMPTOTICS
/
&MAIN_FIT
/
&HOLE_FIXING
/
&SYS_SETTINGS
/
\end{verbatim}

In this case, default values are used for all options in all seven categories. All available options are described in Sec.~\ref{sec:options}. In addition, the examples provided with autoPES may be used as a template.

\subsection{System specification file}\label{subsec:input}
The {\tt NAME.input} file has the following structure
\bigskip \\
\noindent
{\tt *MONOA}\\
  $N{\rm _A}$~$q_{\rm A}$\\
  $a_1\quad   x_{A1}\quad   y_{A1}\quad   z_{A1}\quad   q_{A1}\quad   s_{A1}\quad   t_{A1} $\\
  $a_2\quad   x_{A2}\quad   y_{A2}\quad   z_{A2}\quad   q_{A2}\quad   s_{A2}\quad   t_{A2} $\\
  $\dots$\\
{\tt **CHIRAL}\\
{\tt *MONOB}\\
  $N_B$~$q_B$\\
  $b_1\quad   x_{B1}\quad   y_{B1}\quad   z_{B1}\quad   q_{B1}\quad   s_{B1}\quad   t_{B1} $\\
  $b_2\quad   x_{B2}\quad   y_{B2}\quad   z_{B2}\quad   q_{B2}\quad   s_{B2}\quad   t_{B2} $\\  
  $\dots$\\
{\tt **CHIRAL}\\
{\tt *UNIT}\\
 unit\\
{\tt *COMPONENTS}\\
  $1$~$P_{\rm els}^1$~$P_{\rm pol}^1$~$P_{\rm i+d}^1$~$P_{\rm exp}^1$\\
  $2$~$P_{\rm els}^2$~$P_{\rm pol}^2$~$P_{\rm i+d}^2$~$P_{\rm exp}^2$\\
  $\dots$
\noindent
\\

The {\tt NAME.input} file is organized into sections, with the start of each section indicated by an asterisk followed by the section label. Additionally, sections may contain subsections which are indicated by two asterisks followed by the subsection label. The sections {\tt MONOA} and {\tt MONOB} are required, while all other sections and subsections are optional. The placement of the sections within the input file is arbitrary.

\begin{itemize}
\item The format of section {\tt MONOA} is organized as follows: the first line contains two whole numbers: $N_{\rm A}$, specifying the number of atoms in monomer A, and $q_{\rm A}$, specifying the charge of monomer A. In the following $N_A$ lines the information about the molecule A should be given. All columns are free-form, i.e., not sensitive to the number of digits or spaces between numbers.

The first column contains a string of characters $a_i$, which is the name of the given atom or off-atomic site in the molecule A. The chemical or any other symbol up to 5 characters can be used, however a symbol for each atom in a given molecule has to be unique. So, for example, if monomer A is a water molecule, then the hydrogen atom can be denoted by its chemical symbol `O', but the two hydrogen atoms must have distinctive symbols, e.g., `H1' and `H2'.

Columns 2, 3, and 4 contain the Cartesian coordinates of the atom $(x_{Ai},y_{Ai},z_{Ai})$.

Column 5 contains the nuclear charge $q_{Ai}$ of the atom, given as a whole number.

Column 6 contains the `symmetry equivalence index' $s_{Ai}$ of the atom. This is a positive integer which should have the same value for those atoms which are equivalent through symmetry. For example, in the water molecule one should assign the same indices to both hydrogen atoms. Note that ``symmetrically equivalent" refers not only to the atomic number of an atom but also its position within the molecule. In some cases, where atoms are not exactly symmetrically equivalent but are approximately so, it may be advantageous to assign them the same $s_{Ai}$ value. This will sacrifice some adjustability of the fit, but reduce the number of free parameters and so reduce the number of grid points required.

Finally, column 7 contains an atom type number $t_{Ai}$, which specifies the atom type of the initial guiding force-field. In the current version of autoPES, the user must manually determine the atom type. This may be accomplished by reading the descriptions of atom types given in the file {\tt \$PATH/ff/FORCE\_FIELD}, where {\tt \$PATH} is the installation directory of autoPES and FORCE\_FIELD is the force-field name specified by the option given in the {\tt NAME.ctrl} file. For example, in the case of the water molecule, if FORCE\_FIELD is set to `oplsaa', then the oxygen atom and hydrogen atoms could use $t_{Ai}$ equal to 63 and 64, respectively. If a value of 0 is given for $t_{Ai}$, then the atom will not contribute to the initial guiding force-field. It is possible to use autoPES without a guiding force-field by setting all $t_{Ai}$ to 0, but this may result in a sub-optimal initial grid point distribution.

\item The section {\tt MONOB} may follow the same format as {\tt MONOA}. In the case that monomer A and monomer B are identical, the section {\tt MONOB} should instead consist of a single line with the keyword `SAME'. If the monomers are different, the symmetry equivalence indices $s_{Bi}$ have to be kept unique through out the whole dimer. In other words, if the same symmetry equivalence indexes are given to an atom from the monomer A and an atom form the monomer B, they will be treated as symmetry equivalent.

\item The subsection {\tt CHIRAL} may be included in sections {\tt MONOA} and/or {\tt MONOB}. It indicates that the monomer is chiral, and that the potential should be generated for both same-handed and opposite-handed interactions. The {\tt CHIRAL} subsection contains no additional lines except the subsection label.

\item The {\tt UNIT} section specifies what units of length are used to specify the geometry in the {\tt MONOA} and {\tt MONOB} sections. This section should consist of a single line, containing either the keyword `angstrom' or `bohr'. If the {\tt UNIT} section is omitted, units of Angstrom are assumed.

\item The {\tt COMPONENTS} section is optional and specifies which components of the complete functional form are to be included for each atom type. Each line of this section corresponds to a single symmetry equivalence index $s_{i}$. The electrostatic, polarization, induction plus dispersion, and exponential components of atom type $s_{i}$ are switched on or off by setting the respective logical values $P_{\rm els}^i$, $P_{\rm pol}^i$, $P_{\rm i+d}^i$, and $P_{\rm exp}^i$ (the $r^{-12}$ term, if used, is considered part of the exponential component). If this section is omitted, all values will default to true, except for polarization and induction plus dispersion components of off-atomic sites (see below). In order to include the polarization model, the option POLARIZABLE must also be enabled in the {\tt NAME.ctrl} file.
\end{itemize}

Below are examples of the {\tt NAME.input} files for two different systems, one with the same monomers, and the other one with different.

\bigskip
H2O2.input:
\begin{verbatim}
*UNIT
bohr
*MONOA
3 0
O      0.0000    0.0000    0.1246   8   1   63
H1    -1.4365    0.0000   -0.9971   1   2   64
H2     1.4365    0.0000   -0.9971   1   2   64
*MONOB
SAME
*COMPONENTS
1 T T T T
2 T F T T
\end{verbatim}

H2ONH3.input:
\begin{verbatim}
*MONOA
3 0
O      0.0000    0.0000    0.1246   8   1   63
H1    -1.4365    0.0000   -0.9971   1   2   64
H2     1.4365    0.0000   -0.9971   1   2   64
*MONOB
4 0
N      0.0000    0.0000    0.0000   7   3   78
H1     0.0000   -1.7720   -0.7211   1   4   79
H2     1.5346    0.8861   -0.7211   1   4   79
H3    -1.5346    0.8861   -0.7211   1   4   79
*UNIT
bohr
\end{verbatim}

In addition to atoms, it is possible to add off-atomic sites to the system geometry. Such sites do not affect ab-initio calculations, but generalize the functional form of the PES. These are typically used on small systems where the atom-atom separations alone are insufficient to represent the PES. To include an off-atomic site, the same syntax should be used as for an atom, but with the values of $q_{i}$ and $t_{i}$ set to zero. The symmetry index $s_{i}$ must still be specified as with atoms. Off-atomic sites must always be listed at the end, after the atoms. In the current version of autoPES, the locations of off-atomic sites are not optimized automatically, but must be specified by the user.

\subsection{Running the program}\label{subsec:running}
Both input files should be located in an otherwise empty directory and the program called with command
\begin{verbatim}
$PATH/bin/autoPES NAME
\end{verbatim}
where PATH is a path to the main autoPES directory. The script will generate several files and subdirectories containing outputs of various parts of the PES development. These can be expected to total about 500~MB to 5~GB in size, depending on the size of the system and number of grid points and iterations used.

The autoPES program may simply be run once, and remain running for the duration of the PES generation. However, because this may take days or even weeks depending on the size of the dimer and the amount of computer resources available, it may be impractical to use autoPES in this way. Therefore, it is possible to terminate the program midway through PES generation and resume running it at a later time. When the autoPES program is called, it will identify the appropriate next step to take based on the contents of the working directory from which it was called. It will then submit the appropriate job, or, if a job is in progress, wait until that job completes. When waiting on a job to complete, autoPES will print a line starting with the word `Awaiting'. This indicates that it is safe to kill the process and restart it at a later time. If the script is terminated when the last line printed does not begin with `Awaiting', there is a possibility of corrupting some part of the PES generation process, and in this case manual user action may need to be taken before restarting autoPES.

Each first-level subdirectory in the autoPES working directory is associated with a slave script, which handles all computations related to that task. When a given task `X' is complete, the slave script creates a {\tt SLAVE\_X\_DONE} file in that subdirectory. Additionally, in order to interface with a job queuing system, autoPES is signaled that a given job `X' is running or complete by the creation of `marker' files {\tt X\_RUNNING} or {\tt X\_DONE}. For example, once the asymptotics task is complete, the autoPES working directory will contain a subdirectory {\tt ASYM}, which contains the files {\tt SLAVE\_ASYM\_DONE}, {\tt ASYM\_DONE}, and {\tt ASYMFIT\_DONE}. If a job is terminated before it completes, autoPES will think that the job is still running. In this case, manual action must be taken to re-run the appropriate job, see below.

Individual components of the PES calculation may be recomputed by removing or renaming the appropriate directory within the main running directory and then restarting autoPES. These directories are described in detail in Sec.~\ref{sec:structure}. In addition, an individual SAPT calculation $i$ may be recomputed by removing the corresponding {\tt \$PATH/SAPT$n$/PART$i$} subdirectory. In the case that the entire batch $n$ of SAPT calculations has already completed, the file {\tt SAPT$n$/SLAVE\_SAPT\_DONE} must also be removed. See also the `clean' option described in Sec.~\ref{subsec:runmodes}.

The user may wish to alter various options part way through the PES generation. This may in general be done by exiting autoPES as described above, then making the appropriate changes in the {\tt NAME.ctrl} file. The changes will take effect at the next part of the PES generation which they affect. In order to alter some previously-computed part of the PES generation, the user must remove that directory in addition to making changes to the {\tt NAME.ctrl} file. Specific options may require additional precautions when changed part way through a PES generation. Any such precautions are described in Sec \ref{sec:options}.

The user may want to make changes to the {\tt NAME.input} file midway through a PES generation in order to modify the functional form of the fit. While the atomic coordinates should never be altered, the values $s_{i}$ and $t_{i}$, as well as off-atomic sites may be changed. If any of the $s_{i}$ values or off-atomic sites are altered, the asymptotic fitting must be re-run. This may be accomplished by removing the files {\tt ASYM/SLAVE\_ASYM\_DONE} and {\tt ASYM/ASYMFIT\_DONE}.

\subsection{Special run modes}\label{subsec:runmodes}
In addition to the normal operation outlined above, it is possible to run autoPES in special modes which may be useful. This may be done with the command
\begin{verbatim}
$PATH/bin/autoPES NAME MODE
\end{verbatim}
where MODE is one of the following:
\begin{enumerate}
\item {\bf clean} -- When run in `clean' mode, autoPES will, when encountering an incomplete batch of SAPT calculations, first prompt the user before removing all incomplete or failed calculations in that batch. If a batch is already completed and the user wants to re-run failed calculations, he/she should first remove the corresponding SAPT$n$/SLAVE\_SAPT\_DONE file. Note that this will retain any calculations which have already been marked as complete, and will only remove failed or incomplete calculations.
\item {\bf compress} -- When run in `compress' mode, autoPES will, when encountering a completed iteration of {\em ab initio} calculations (i.e., a SAPT$n$ or DELTAHF$n$ directory containing the file SLAVE\_SAPT\_DONE), place the output files and directories from those calculations into compressed archives and remove the original, uncompressed files. This option is useful if the PES files are taking an excessive amount of disk space. Using the `compress' feature does not compress the grid point coordinates or interaction energies which are used by autoPES and will have no effect on the functioning of autoPES. However, if the user later wishes to view the {\em ab intio} output files, they must first manually decompress the appropriate {\tt SAPT$n$/archive.tar.gz} file.
\item {\bf xyz} -- When run in `xyz' mode, autoPES will attempt to add geometries from .xyz files to the set of grid points. Before running this, the user should create a directory {\tt XYZ} in the autoPES running directory, and place the desired .xyz files there. Each unique dimer geometry should be in its own .xyz file in the standard format, with the number of atoms equal to the number of atoms in the dimer. The order of atoms in the file is arbitrary. The program will report which files were successfully identified as valid dimer geometries and create a new SAPT$n$ directory containing the new points. autoPES must be re-run as normal (i.e., without the `xyz' run mode) to begin the actual SAPT calculations. After completing the SAPT calculations, autoPES will then re-fit the PES.
\end{enumerate}

\subsection{Using the results}
The results of each fit may be found in the {\tt FIT$n$} directories. The directory with the largest $n$ is typically the most recent fit. The file {\tt FIT$n$/fit\_report.out} contains a description of the fit in human-friendly and LaTeX formats. The file {\tt FIT$n$/fit\_inter.dat} contains all intermolecular fit parameters in a machine-friendly format. The structure of the {\tt fit\_inter.dat} file is described in Sec. \ref{subsec:files}.

\subsubsection{Compute the fitted interaction energy of a PES}
The program {\tt eval\_pes} can be used to evaluate the value of the potential at a given geometry. To use {\tt eval\_pes}, first prepare a file in {\tt .xyz} format containing the dimer geometry, with the atoms appearing in the same order that they do in the {\tt NAME.input} file, with monomer A first and monomer B second. The program may then be used with the command
\begin{verbatim}
$PATH/bin/eval_pes $PARM_FILE < $GEO_FILE
\end{verbatim}
where \$PARM\_FILE is the generated {\tt fit\_inter.dat} file and \$GEO\_FILE is the .xyz geometry file. The result is sent to the standard output.

\subsubsection{Convert to Cartesian coordinates}
The program {\tt toxyz} can be used to convert from the $R$ and Euler angle coordinates used by autoPES to Cartesian coordinates in the standard .xyz format. The {\tt toxyz} program must be run from a directory containing the {\tt NAME.input\_long} file (see Sec.~\ref{subsec:files}). The coordinates are given in the same format as the {\tt NAME.ener} file (see Sec.~\ref{subsec:files}) to the standard input. The program may be run with the command
\begin{verbatim}
echo `5 0 0 0 0 0' | $PATH/bin/toxyz $NAME
\end{verbatim}
where \$NAME is the name of the system. In this example, the COM-COM distance is $5.0~\rm\AA$ and all Euler angles are set to zero degrees, meaning neither monomer is rotated from its starting orientation. The result is sent to the standard output.

In order to evaluate the PES at a configuration specified by $R$ and Euler angles, the {\tt eval\_pes} and {\tt toxyz} programs may be chained together like so:
\begin{verbatim}
echo `5 0 0 0 0 0' | $PATH/bin/toxyz $NAME | $PATH/bin/eval_pes $PARM_FILE
\end{verbatim}

\subsubsection{Create DL\_POLY inputs}
The program {\tt make\_dlpoly\_inp} can be used to create input files for the DL\_POLY molecular dynamics simulation package \cite{dlpoly}. Currently, this option does not support the polarization model. The {\tt make\_dlpoly\_inp} program creates two input files: TABLE and FIELD. The TABLE file contains a description of the PES, excluding electrostatics and polarization components, in a tabulated form. The FIELD file contains molecular geometries and partial charges. The TABLE file generated by {\tt make\_dlpoly\_inp} is typically usable as-is, but the FIELD file should be treated as a template only and will generally require some modification depending on the intended application. For a full description of these files, see the DL\_POLY user manual \cite{Forester:95}. The program may be run with the command
\begin{verbatim}
$PATH/bin/make_dlpoly_inp $NAME $PARM_FILE $R_CUTOFF
\end{verbatim}
where \$NAME is the name of the system, \$PARM\_FILE is the generated {\tt fit\_inter.dat} file, and \$R\_CUTOFF is the potential cutoff radius used by DL\_POLY, specified in Angstrom.

\subsection{Parallelization} \label{subsec:par}
To enable OpenMP parallelization of certain processor intensive programs in autoPES, the OMP option in the {\tt \$PATH/compall} script should be set to `YES'. This does not affect the SAPT dimer calculations, which consume the vast majority of the total CPU time required for PES generation. However, because the SAPT dimer calculations may in general be run simultaneously, enabling this option will typically result in significantly reduced wall time. If autoPES is compiled with the OMP option enabled, the NCORES option is used to set the number of parallel threads (see Sec.~\ref{sec:options}).

In addition to the OpenMP option mentioned above, the PES generation procedure naturally allows for a large degree of parallel processing because the SAPT calculations for each grid point are independent. This is typically done through the computer's job queuing system using the options MAX\_SIM\_PT and NPART\_PER\_JOB (see Sec.~\ref{sec:options}). However, it may be desirable on certain systems to run each individual SAPT calculation on multiple cores. This is accomplished through a combination of parallel BLAS libraries and Message Passing Interface (MPI), and requires both the SAPT package and front-end programs to be properly configured. See appropriate manuals for details. If the SAPT package and interface programs are properly configured, the NCORES\_SAPT option may be used to specify the number of cores to use in each SAPT dimer calculation.

\subsection{Basis sets} \label{subsec:basis}
The autoPES package as distributed has a basis set depository, which contains {\bf aug-cc-pVDZ} and {\bf aug-cc-pVTZ} basis sets \cite{Kendall:92} for the first, second, and third row atoms. Other basis sets can be added by the user by placing an appropriately named file in the {\tt autoPES/basis} directory, in the Gaussian94 format. The main basis set may be chosen using the BASIS option in the {\tt NAME.ctrl} file as specified in Sec. \ref{sec:options}.

Auxiliary basis sets of Weigend \cite{Weigend:02} corresponding to the {\bf aug-cc-pVDZ} and {\bf aug-cc-pVTZ} basis sets are distributed with autoPES. As with the main basis sets, additional auxiliary basis sets may be added to the autoPES depository in the Gaussian94 format. By default, the auxiliary basis corresponding to the chosen main basis is used. A different auxiliary basis may be chosen using the AUXBASIS option.

Midbond functions are by default the set of {\em spdf} functions and corresponding auxiliary basis functions taken from Ref.~\cite{Podeszwa:06b}.

\section{Potential Energy Surface} \label{sec:pes}
The PES has the functional form (see Ref.~\cite{Metz:16}, Sec.~IV)
\begin{equation} \label{eq:pes}
V = V_{\rm ind}(A,B) + \sum\limits_{a \in A} \sum\limits_{b \in B} u_{ab}(r_{ab}) .
\end{equation}
The first term is a polarization model. The second term is a sum of site-site functions, where one site belongs to monomer $\rm A$ and the other to monomer $\rm B$. The set of sites includes all atoms of both monomers, and may also include off-atomic sites if additional accuracy is required.
\begin{equation} \label{eq:uab}
u_{ab}(r_{ab}) =
A \left[1 + \sum\limits_{i=1}^k a^{ab}_i (r_{ab})^i\right] e^{\alpha^{ab} - \beta^{ab} r_{ab}}
+ \frac{A^{ab}_{12}}{(r_{ab})^{12}}
+ f_1(\delta_1^{ab}, r_{ab}) \frac{q_a q_b}{r_{ab}}
- \sum\limits_{n=6,8,10} f_n(\delta_n^{ab}, r_{ab}) \frac{C^{ab}_n}{(r_{ab})^n} .
\end{equation}
Here $r_{ab}$ is the distance between sites, $q_x$ are partial charges on each site, $C^{ab}_n$ are distributed van der Waals coefficients, and $f_n$ are Tang-Toennies damping functions \cite{Tang:84}. The coefficients $A^{ab}_{12}$ are constrained to be positive, and are included to ensure the correct repulsive behavior of the potential at very close range. The factor $A$ is needed for consistency of energy units, and equal to 1 kcal/mol in the case that all other parameters have the units specified in Sec.~\ref{subsec:files}. Any of the sites in the fit may optionally exclude electrostatic, polarization, dispersion, or exponential components. In the case that one or both monomers has nonzero charge, the last summation in Eq.~\ref{eq:pes} starts with $n=4$ rather than $n=6$ in order to reproduce the correct asymptotic behavior of the induction energy.

The polarization model defining $V_{\rm ind}$ consists of a set of
induced point-dipoles ${\bm \mu}_a^{\rm ind}$ on each site $a \in A$
(and analogously for $b \in B$), defined as
%
\begin{equation} \label{eq:mu}
{\bm \mu}_a^{\rm ind} = \alpha_a\left[\bm{\mathcal{E}}_a +
      \sum\limits_{b \in B} {\bm T_{ab}} {\bm \mu}_b^{\rm ind} \right] ,
\end{equation}
%
where $\alpha_a$ is an isotropic polarizability assigned to a site $a$, 
$\bm{\mathcal{E}}_a$ is the damped electric field at point $a$ due to all
permanent point charges $q_b$ of monomer B
%
\begin{equation} \label{eq:efield}
\bm{\mathcal{E}}_a = \sum\limits_{b \in B} 
f_1(\delta_1^{ab}, r_{ab})\frac{q_b\bm r_{ab} \rm}{r_{ab}^3} ,
\end{equation}
and ${\bm T}_{ab}$ is the damped dipole-dipole 3$\times$3 interaction tensor
%
\begin{equation} \label{eq:diptensor}
{\bm T_{ab}} = f_3(\delta_{\rm p}^{ab}, r_{ab})
\left[ \frac{{\bm r}_{ab} \otimes {\bm r}_{ab}}{r_{ab}^{5}} - \frac{1}{r_{ab}^{3}} \right],
\end{equation}
%
with $\bm r_{ab}$ denoting the displacement vector from site $a$ to site $b$
and $\otimes$ denoting the Kronecker product.
The summations in Eqs. (\ref{eq:mu}) and (\ref{eq:efield}) are over atoms in monomers other than the one in which the atom $c$ resides. After the set of equations is solved iteratively, the energy contribution from the polarization model is given by
\begin{equation}\label{eq:polener}
V_{\rm ind} = -\frac{1}{2}\sum\limits_{c} \bm{\mathcal{E}}_c \cdot {\bm \mu}_c^{\rm ind} ,
\end{equation}
where the sum is over all atoms $c$ in both monomers.

The two-body implementation of the polarization model can easily be extended to more bodies by making the summations in Eqs.~\ref{eq:efield} and \ref{eq:diptensor} over atoms in monomers other than the one in which the atom $c$ resides and summing Eq.~\ref{eq:polener} over atoms in all monomers.

\section{Options} \label{sec:options}
The autoPES package allows user to control the following settings via the {\tt NAME.ctrl} file, which should be prepared in the FORTRAN namelist format (see Sec.~\ref{subsec:ctrl}).
\begin{enumerate}
\item Namelist: GENERAL
\begin{itemize}
\item MIN\_GRIDGEN\_ITER: integer -- This is the minimum number of iterations (excluding hole-fixing iterations) to be performed beyond the initial one, regardless of whether or not the convergence criteria is met. It is recommended to use at least one iteration to ensure accuracy around the minima of the PES. Default value is 1.
\item TEST\_PCT: integer -- Percentage of the grid points to be used as a test set for evaluating the quality of the potential. Once the convergence criterion is met, all of the grid points are used for the final fit. Default value is 20.
\item TEST\_CONV: real -- The maximum difference in error between fit data and test data to use in PES convergence criteria. The PES will be considered converged, and iterations will no longer be performed (excluding hole-fixing iterations), when $\rm (test RMSE) < (1 + TEST\_CONV)*(fit RMSE)$. Default value is 0.2.
\end{itemize}

\item Namelist: AB\_INITIO
\begin{itemize}
\item METHOD: string -- The name of the {\em ab initio} method to use. Currently supported values are `SAPTDFT', indicating SAPT(DFT) calculation, and `CCSDT', indicating counterpoise-corrected supermolecular CCSD(T) calculation. Default value is `SAPTDFT'.
\item BASIS: string -- Name of the basis set which will be used for all {\em ab initio} calculations. The program does not allow to use different basis sets in different parts of the computations, hence the ionization potential calculations, the asymptotic calculations and the main {\em ab initio} calculations use the same basis set. Midbond functions are enabled by default and may be disabled using the MB\_CUTOFF option. The aug-cc-pVDZ and aug-cc-pVTZ basis sets are distributed with autoPES, and others can be added, see Sec.~\ref{subsec:basis}). Default value is `aug-cc-pVDZ'.
\item AUXBASIS: string -- The name of the auxiliary basis used for SAPT density fitting calculations. Default value is BASIS-RI, where BASIS is the value of the above option. See Sec.~\ref{subsec:basis} for more details.
\item HYBRID: logical -- Specifies whether the hybrid PBE0 functional (T) or non-hybrid PBE functional (F) is used for SAPT(DFT) calculations. Default value is false.
\item DELTAHF: string/logical -- Specifies whether or not to include the $\delta E^{\rm HF}_{\rm int,resp}$ correction for SAPT(DFT) runs. This correction typically increases the computer time required for each grid point by about 60\%, and is important for highly polar systems such as water. See the SAPT manual for details. Valid values of DELTAHF are `T', `F', or `AUTO'. The AUTO setting determines whether to include $\delta E^{\rm HF}_{\rm int,resp}$ based on the criteria described in Ref.~\cite{Metz:16}. Default value is AUTO.
\item MB\_CUTOFF: real -- For any grid point such that midbond functions placed using the $1/r^6$ weighting method results in a midbond center which is too close to an atom, the midbond functions are removed. This is to prevent divergence of SAPT at close distance. The midbond functions are removed if the the distance between any atom and the midbond center is less than MB\_CUTOFF times the covalent radius of that atom. This option may also be used to remove midbond functions entirely by setting it to a large value, e.g. 1.0E10. Default value is 0.8.
\end{itemize}

\item Namelist: GRID\_GENERATION
\begin{itemize}
\item FORCE\_FIELD: string of characters, maximal length 20 -- name of the molecular mechanics force field which will be used as the initial guiding function in the grid generation process. The default value of this variable is {\bf oplsaa}, which refers to the all atoms OPLS force field \cite{Jorgensen:96}. This is the only force filed which is included with the autoPES package installation. However, users can add other force fields as required. Such force fields should be placed in the {\tt ff} subdirectory of the autoPES installation directory, and the FORCE\_FIELD option should correspond to the file name.
\item GRID\_SIZE: integer -- the size of the initial grid for the {\em ab initio} calculations. Additional points will be added during the iteration stages. If set to 0, the initial grid size will be set to ${\rm GRID\_SIZE} = N_{\rm FP}*6*100/(100 - {\rm TEST\_PCT})$, where $N_{\rm FP}$ is the number of free parameters in the main PES fitting stage. Default value is 0.
\item GRID\_ADD\_PCT: integer -- The number of points to add in each iteration (excluding hole-fixing iterations), expressed as a percentage of GRID\_SIZE. Default value is 20.
\item GRID\_WEIGHT\_SCALE: real -- Specifies the strength of the exponential weighting used in the generation of grid points. A smaller value will favor sampling of lower energy configurations more, while a larger value will give more uniform sampling. See Eq.~4 of Ref.~\cite{Metz:16}. Default value is 1.2.
\item GRID\_MINIMA\_PCT: integer -- This percentage of points in the initial grid will be generated around the minima of the guiding potential, with the remainder generated throughout the configuration space using a Monte Carlo method. Default value is 10 (meaning 10\%).
\item GRID\_MINIMA\_PCT\_ADD: integer -- Same as GRID\_MINIMA\_PCT, but applying to second and later iterations rather than to the initial grid. It is recommended that this value is set higher than GRID\_MINIMA\_PCT to ensure accuracy around the true minima of the PES. Default value is 20 (meaning 20\%).
\end{itemize}

\item Namelist: ASYMPTOTICS
\begin{itemize}
\item MAX\_ CN: integer -- the highest power used in the distributed asymptotic induction plus dispersion expansion. The minimum value is set automatically to 6 in the case that neither monomer is charged, and 4 in the case that one or both monomers are charged. Available values are 6, 8 and 10. Default value is 6.
\item COM\_RULE\_CN: integer -- the type of combination rules to use for the ditributed induction plus dispersion parameters. A value of 0 indicates a separate free parameter for each site-pair type, and a value of 1 indicates a single free parameter for each site type, with values between site par types determined using a geometric combination rule.
\item POLARIZABLE: logical -- this variable indicates whether the polarizable model should be used. Default value is F.
%\item DISTR: logical -- Specifies whether COM or distributed asymptotic expansion should be used. Distributed model is recommended for systems larger than about 10 atoms. Default value is F.
\end{itemize}

\item Namelist: MAIN\_FIT
\begin{itemize}
\item POLY\_ORDER: integer -- Order of the linear polynomial factor in the exponential term of the PES functional form. This choice reflects a trade-off between the accuracy of the fit and the number of grid points required. It is always recommended to use at least a first order polynomial if possible. A second order polynomial usually improves accuracy significantly over a first order one. A third order polynomial can sometimes be useful for small systems, but usually does not have a large effect. The use of polynomial order greater than 3 is generally not beneficial. Valid range is 0 to 5, with default value of 2.
\item FIT\_WEIGHT\_SCALE: real -- Value used in setting of fitting weights. The weight of a point with interaction energy $E_i$ is set to $w_i = {\rm exp}(-[E_i - E_{\rm min}]/E_{\rm w})$, where $E_{\rm min}$ is the global minimum energy of the PES and $E_{\rm w} = [{\rm FIT\_WEIGHT\_SCALE}][|E_{\rm min}| + 4 {\rm kcal/mol}]$. See Eqs.~19 and 20 of Ref.~\cite{Metz:16}. A smaller value results in stronger weighting of more attractive regions, while a larger value gives more even weighting. Default value is $0.15$.
\item COM\_RULE\_EXP: integer -- Indicates the type of combination rule to use for the exponential $\alpha_{ab}$ and $\beta_{ab}$ fit parameters. A value of 0 indicates a separate value for each site-pair, and 1 indicates a single value per site, with values between pairs obtained by an arithmetic combination rule. For dimers larger than about 10 atoms, the use of separate parameters for each site-pair typically does not yield a significant increase in accuracy in comparison to the increased number of grid points needed to fit the extra free parameters. However, for smaller dimers, especially if off-atomic sites are used, it may be beneficial to set this option to 0. Default value is 1.
\item COM\_RULE\_LIN: integer -- Indicates the type of combination rule to use for the linear $a$ fit parameters. A value of 0 indicates a separate value for each site-pair, and 1 indicates a single value per site, with values between pairs obtained by an arithmetic combination rule. Default value is 0.
\item COM\_RULE\_DAMP: integer -- Indicates the type of combination rule to use for damping parameters in the distributed electrostatics and induction plus dispersion expansions. A value of 0 indicates a separate value for each site-pair, 1 indicates a single value per site with values between pairs obtained by a geometric combination rule, and 2 indicates a single value for all damping parameters. Default value is 1.
\item ELS\_DMP: logical -- Sets whether or not Tang-Toennies damping will be used for the electrostatic component of the PES. Default value is F (meaning damping is not used).
\item CN\_DMP: logical -- Sets whether or not Tang-Toennies damping will be used for the induction plus dispersion component of the PES. Default value is T (meaning damping is used).
\item FIT\_A12: logical -- Sets whether to use the repulsive $r^{-12}$ term of Eq. (\ref{eq:pes}). Including this term may reduce the number of grid points required for hole fixing. Default value is F.
\item FIT\_AUTO\_REDUCE: real -- The functional form of the fit will be automatically simplified such that the number of fitting points in each stage of the fitting is no less than FIT\_AUTO\_REDUCE times the number of free parameters in that stage. Simplifications are done by introducing combination rules or reducing the polynomial order. This is enabled by default because if there are not enough data points to fit the full functional form, the resulting potential may be of very poor quality. Note that this feature will only have an effect if the user changes the functional form of the fit to include a larger number of free parameters after the number of grid points is determined, or if the user manually sets the number of grid points to a value which is too small given the functional form. Default value is 2.0.
\end{itemize}

\item Namelist: HOLE\_FIXING
\begin{itemize}
\item WALL\_HEIGHT: real -- The minimum required height of the repulsive wall for any orientation, in kcal/mol. See Sec.~VII of Ref.~\cite{Metz:16}. Default value is 15.0.
\item WALL\_MIN\_DIST: string/real -- Specifies the minimum distance at which hole fixing points are added. Given as a ratio of the distance between the the nearest pair of atoms in a given configuration to the sum of the covalent radii of those atoms. A typical value is 1.3, or smaller for strongly attracting systems. If set to `AUTO', the distance will be automatically determined based of energies of previously computed grid points (see Sec.~VII of Ref.~\cite{Metz:16}). Default value is AUTO.
\item HOLE\_ADD\_PCT: integer -- The maximum number of points to add in each hole-fixing iteration, expressed as a percentage of the initial grid size. Setting this to a higher value may decrease the number of hole-fixing iterations, but may also result in less efficient use of computer resources. Default value is 10 (meaning 10\%).
\end{itemize}

\item Namelist: SYS\_SETTINGS
\begin{itemize}
\item NCORES: integer -- The number of parallel cores to be used by all components of autoPES. The autoPES programs which support OpenMP parallelizition do not account for a large portion of the overall CPU time of the PES generation, but can significantly increase overall wall time if only one core is used here. Therefore the use of about 4 to 8 cores is recommended if available. Default is 1.
\item NCORES\_SAPT: integer -- The number of parallel cores to be used in SAPT calculations. Given a properly configured installation, SAPT calculations can be expected to scale reasonably well up to about 8 cores. Default value is 1.
\item NCORES\_SCF: integer -- The number of parallel cores to be used by the front-end program in SAPT calculations. In the case that supermolecular calculations are used in place of SAPT, this value will be used to select the number of cores. A value of 0 indicates that NCORES\_SCF will be set to the value of NCORES\_SAPT. Default value is 0.
\item NPART\_PER\_JOB: integer -- The number of SAPT points to calculate in parallel in each job submitted to the queuing system. This option is intended for computer systems which require an entire node to be reserved for each job. If this constraint is not present, this should be left at the default value of 1.
\item MAX\_SIM\_PT: integer -- The maximum number of SAPT calculations that may be submitted to the queuing system at the same time. If the autoPES program is left running (see Sec.~\ref{subsec:running}), it will automatically submit additional grid points as others finish to maintain this many jobs in the queue. On many systems, MAX\_SIM\_PT may be set to a large value so that autoPES submits all points simultaneously, and the queuing system is left to run jobs appropriately. Default value is 1.
\item SAPT\_MEM: integer -- Each SAPT calculation will be limited to this many million 8-byte words of virtual memory. A value of 0 indicates that SAPT will use the amount of memory required for optimal performance. SAPT can run with less memory with some performance penalty, and this option may be used to reduce the required memory. To determine the minimum amount of memory that SAPT needs to run, the SAPT memory estimator may be used (see the SAPT package manual for details). If CCSD(T) calculations are used in place of SAPT, this value is used to set the `maxcore' option in ORCA (the value in this case is still given in millions of words, and is converted by the program to units appropriate for ORCA). Default value is 0.
\item SAPT\_TIMEOUT: integer -- If a grid point begins computing and does not finish after this number of minutes, it will be assumed to have failed and will be discarded. Zero means no timeout. Default value is 0.
\item SAPT\_QUEUE\_TIMEOUT: integer -- If a grid point calculation is submitted to the queue and does not begin running after this number of minutes, it will be assumed to have failed and will be discarded. Zero means no timeout. Default value is 0.
\end{itemize}
\end{enumerate}

\section{Structure of the program} \label{sec:structure}
\subsection{Program flow}
The autoPES package has a modular structure in which different subprograms are called and coordinated by the main script {\tt master.sh}. The master script is itself called by the front-end program called autoPES, whose only job is to initialize default values of variables and read in user's settings. When launched, the master script will identify the appropriate next step of PES generation based on the presence of files and directories within the main running directory. All computationally expensive tasks are associated with their own directory and are handled by a corresponding slave script. This procedure is outlined below.

\begin{enumerate}
\item Monomer property calculations -- The {\tt IP} (for ionization potential) directory is created and the {\tt slave\_ip.sh} script is called, which performs the following steps:
\begin{itemize}
\item Input files for {\em ab initio} calculations are created with the {\tt make\_ip\_inp} program.
\item Jobs corresponding to neutral monomer A and ionized monomer A are submitted. In the case of different monomers, two jobs are also submitted for monomer B. The script then waits for all jobs to finish.
\item Ionization potentials, dipole moments, and polarizabilities are extracted from the {\em ab initio} outputs.
\end{itemize}

\item Asymptotic calculation -- The {\tt ASYM} directory is created and the {\tt slave\_asym.sh} script is called, which performs the following steps:
\begin{itemize}
\item Inputs are generated for the SAPT asymptotic codes and a job is submitted to run the asymptotic calculations using the Dalton 2.0 interface (see the SAPT manual \cite{SAPT2016} for details). This results in a grid of long-range interaction energies, whose energy components are stored in the file {\tt NAME.ener\_asym}.
\item Inputs are generated for the asymptotic fitting codes, and a job is submitted to fit the long-range PES parameters to the grid of energies using the program {\tt fit\_asymp} (see Ref.~\cite{Metz:16}, Sec.~V for details).
\end{itemize}

\item Grid generation -- The {\tt GRID$n$} directory is created, where $n$ is the iteration number, and the {\tt slave\_gridgen.sh} script is called, which performs the following steps:
\begin{itemize}
\item A job is submitted to run the script {\tt find\_minima.sh}, which locates the local minima of the PES, and generates grid points around the local minima, stored in the file {\tt NAME.geo\_min} (see Ref.~\cite{Metz:16}, Sec.~IIB for details).
\item A job is submitted to compute the main grid using the {\tt gridgen\_ff} program, stored in the file {\tt NAME.geo\_main} (see Ref.~\cite{Metz:16}, Sec.~IIA for details).
\item The script waits for both jobs to complete and the results are combined into a single grid.
\end{itemize}

\item {\em ab initio} calculations -- The {\tt SAPT$n$} directory is created and the {\tt slave\_sapt.sh} script is called, which performs the following steps:
\begin{itemize}
\item Inputs are created for the {\em ab initio} codes. For each point $i$ in the grid, a subdirectory {\tt SAPT$n$/PART$i$} is created.
\item The script begins creating, submitting, and awaiting the completion of jobs until all {\em ab initio} calculations are complete. For each job $j$ that is submitted, a subdirectory {\tt SAPT$n$/JOB$j$} is created, which contains soft links to each of the PART$i$ directories corresponding to grid points packaged within that job. The number of grid points per job is selected using the option NPART\_PER\_JOB. For each job $j$ which completes, the file {\tt SAPT$n$/JOB$j$/FINALIZED} is created. For each grid point $i$ which is packaged into a job, the file {\tt SAPT$n$/PART$i$/SUBMITTED} is created. When the grid point $i$ calculation completes, one of the files {\tt SAPT$n$/PART$i$/SUCCESS} or {\tt SAPT$n$/PART$i$/FAILED} is created. A job may fail due to bad output or timeout, as described in Sec.~\ref{sec:options}. Outputs of {\em ab initio} calculations are stored in the {\tt SAPT$n$/PART$i$/NAME.log} files.
\item When all parts have either succeeded or failed, the results are combined into the file {\tt SAPT$n$/NAME.ener}.
\end{itemize}

\item Delta-HF calculations -- If delta-HF calculations are to be performed, the {\tt DELTAHF$n$} directory is created and the {\tt slave\_sapt.sh} script is called, which performs the following steps:
\begin{itemize}
\item Inputs are created for the SAPT delta HF codes, and the calculations are performed as with the SAPT calculations described above.
\item The program {\tt combine\_ener} is used to combine the results of the main SAPT calculations and delta-HF calculations.
\end{itemize}

\item Main PES fitting -- The FIT$n$ directory is created and the {\tt slave\_fit.sh} script is called, which performs the following steps:
\begin{itemize}
\item The input grid is randomly split into fitting and testing components (unless the TEST\_PCT option is set to 0 or if the final fitting iteration has been reached).
\item A job is submitted to run the main fitting program {\tt fit\_inter} (see Ref.~\cite{Metz:16}, Sec.~VI for details). The script waits for fitting to complete.
\item A job to execute the hole scanning program {\tt hole\_scan} is submitted (see Ref.~\cite{Metz:16}, Sec.~VII for details).
\item A job is submitted to run the script {\tt find\_minima.sh}, which locates the local minima of the PES.
\item The script waits for hole scanning and minima localization to complete, then runs the program {\tt gen\_report} to create a human readable report.
\end{itemize}

\item Additional iterations -- Based on the result of the above fitting step, additional iterations may be performed:
\begin{itemize}
\item If the hole scanning procedure identified any holes, then the next iteration begins with the SAPT calculation steps and hole-fixing points are computed.
\item If there were no holes found but the accuracy criteria were not met by the previous fit, the next iteration begins with the grid generation step and more grid points are computed.
\item If the accuracy criteria were met and no holes were found, a final fitting stage is begun in which there is no test set, i.e., the fit is performed on the entire set of grid points.
\item If the final fitting stage is complete and no holes were found, the master script terminates.
\end{itemize}

After the completion of each step, the autoPES master script identifies the next action to be performed based on the subdirectories present in the main running directory, and the files {\tt SLAVE\_X\_STARTED} and {\tt SLAVE\_X\_DONE} in those subdirectories. It is always possible to manually remove a subdirecory when autoPES is not running, and autoPES will re-run the necessary calculations the next time it is launched. One may also, for example, manually create a directory {\tt FIT$n$} (where $n$ is any positive integer less than 1000 which is not yet used) after altering the {\tt NAME.ctrl} file in order to perform an additional fit with a modified functional form.

\end{enumerate}

\subsection{Directory structure}
The autoPES package has the following directory structure when extracted
\begin{enumerate}
\item {\bf basis} -- directory containing the main and auxiliary basis sets
\item {\bf bin} -- directory containing all scripts and compiled binaries
\item {\bf doc} -- directory containing documentation
\item {\bf example} -- directory containing example runs
\item {\bf ff} -- directory containing guiding force field parameters
\item {\bf src} -- directory containing all source files for FORTRAN programs
\end{enumerate}

\subsection{Internal file formats} \label{subsec:files}
The most important internal files created by autoPES are described below.

\begin{itemize}
\item {\bf fit\_asymp.dat} -- The {\tt fit\_asymp.dat} file is created by the asymptotics fitting program {\tt fit\_asymp}, and contains parameter values of the aymptotic part of the fit. It is read in by the complete PES fitting program {\tt fit\_inter}.

An example {\tt fit\_asymp.dat} file for the water dimer is given below. In this example, the distributed induction plus dispersion expansion includes $1/r^6$, $1/r^8$, and $1/r^{10}$ terms, and no polarization model. There are three off-atomic site types, with only the first including the electrostatic interaction, and all three excluding the induction plus dispersion interaction.
\begin{verbatim}
   8  -0.343214985865E+00   0.000000000000E+00
   1  -0.573834190669E+00   0.000000000000E+00
   0   0.745441683602E+00   0.000000000000E+00
   0   0.000000000000E+00   0.000000000000E+00
   0   0.000000000000E+00   0.000000000000E+00
    3     1     6
 0.38808197E+03  0.16822993E+04  0.10326998E+05
 0.15407220E+02  0.49764340E+02  0.55628460E+02
 0.00000000E+00  0.00000000E+00  0.00000000E+00
 0.00000000E+00  0.00000000E+00  0.00000000E+00
 0.00000000E+00  0.00000000E+00  0.00000000E+00
\end{verbatim}
\begin{itemize}
\item The first section of the file contains one line per site type, with three items per line. The first item is an integer giving the atomic number of the site type, with 0 used for off-atomic sites. The next two items are the partial charge $q_i$ and polarizability $\alpha_i$ of the site type in atomic units.
\item The next line contains three integers. The first specifies the number of terms in the induction plus dispersion expansion. The second is the combination rule used for the induction plus dispersion expansion, with 1 indicating a geometric combination rule and 0 indicating no combination rule. The third gives the starting power of the induction plus dispersion expansion.
\item The next section contains one line per site type in the case that the combination rule is used for the induction plus dispersion expansion, and one line per site-pair type in the case that no combination rule is used. Each line contains the $C_n$ values ($n = 6,8,10$ in this example) in units of ${\rm kcal/mol}\times{\rm \AA}^n$.
\end{itemize}

\item {\bf fit\_inter.dat} -- The {\tt fit\_inter.dat} file is created by the intermolecular fitting program {\tt fit\_inter} after each fitting iteration, and contains all parameter values for the intermolecular fit.

An example {\tt fit\_inter.dat} file for the water dimer is given below. In this example, a second order linear polynomial, only $1/r^6$ terms in the distributed induction plus dispersion expansion, no $1/r^{12}$ term, no polarization model, and damping on the induction plus dispersion terms but not the electrostatic terms are used.
\begin{verbatim}
    2    1    6
    3    3
    1    2    2
    1    2    2
    0
   -0.66511861858500     0.00000000000000
    0.33255930929200     0.00000000000000
    3
  1   1   0.1762204262E+01   0.8535985399E+01  -0.4706936353E+00   0.3256953933E-01
        0.4263898800E+03   0.0000000000E+00  0.1000000000E+11   0.3779051073E+01
  1   2   0.2306443439E+01   0.7524902319E+01  -0.1069960862E+01   0.3256862308E+00
        0.8129749810E+02   0.0000000000E+00  0.1000000000E+11   0.3779243972E+01
  2   2   0.2714369711E+01   0.6493695095E+01  -0.1453342674E+00  -0.2585688450E+00
        0.1550056300E+02   0.0000000000E+00   0.1000000000E+11   0.3779116411E+01
\end{verbatim}
\begin{itemize}
\item The first line contains three integers, specifying the linear polynomial order, number of terms per site-pair in the distributed induction plus dispersion expansion, and the first power of the distributed induction plus dispersion expansion. In cases where there is more than one term in the induction plus dispersion expansion, powers increase by two starting from the first power.
\item The second line contains two integers, specifying the number of sites in monomer A and in monomer B.
\item The next line specifies site type indices $s_i$ of each site $i$ of monomer A (as given in the {\tt NAME.input} file). The next line is an analogous one for monomer B.
\item The next line specifies the number of optimized off-atomic site groups. In the current version of autoPES, it should always equal 0.
\item The next group of lines specifies partial charges and isotropic polarizabilities of each site type, with one line per site type. Both values are in atomic units.
\item The next line (line number 7 in the above example) contains one integer specifying the number of site-pair types. This corresponds to the number of lines in the next section of the file.
\item The remaining lines contain the site-pair parameters, with each line corresponding to one site-pair type. The columns are as follows, with parameters defined in Sec.~\ref{sec:pes} (note that each two consecutive lines here form one line in the file)
\begin{itemize}
\item site type $a$
\item site type $b$
\item $\beta^{ab}$~$({\rm \AA}^{-1})$ 
\item $\alpha^{ab}$~(unitless)
\item $a^{ab}_i$~$({\rm \AA}^{-i})$; one column for each term in the linear polynomial, $i = 1,...,k$
\item $C^{ab}_n$~$({\rm kcal/mol}\times{\rm \AA}^n)$; one column for each term in the distributed induction plus dispersion expansion
\item $A^{ab}_{12}$~$({\rm kcal/mol}\times{\rm \AA}^{12})$
\item $\delta^{ab}_1$~$({\rm \AA}^{-1})$
\item $\delta^{ab}_n$~$({\rm \AA}^{-1})$; one column for each term in the distributed induction plus dispersion expansion
\item $\delta^{ab}_{\rm p}$~$({\rm \AA}^{-1})$
\end{itemize}
Note that the columns are included even if the chosen functional form does not use those parameters. In the case of unused damping parameters, a large value is given, which indicates that the damping factor is equal to unity.
\end{itemize}

\item {\bf NAME.ener} -- Each {\tt NAME.ener} file contains a set of grid point coordinates and corresponding energies. Multiple {\tt NAME.ener} files are created at different parts of the PES generation, and are located in different directories. New {\tt NAME.ener} files are created after each iteration of {\em ab initio} calculations, and these files are combined into a new {\tt NAME.ener} file before each new fit is performed.

The format of the {\tt NAME.ener} file is given below.
\bigskip \\
\noindent
 $R^1$~$\beta_{\rm A}^1$~$\gamma_{\rm A}^1$~$\alpha_{\rm B}^1$~$\beta_{\rm B}^1$~$\gamma_{\rm B}^1$~$\phi_1^1$ ... $\phi_{N_{\rm ID}}^1$~$E_{\rm tot}^1$~$E_{\rm elst}^1$~$E_{\rm exch}^1$~$E_{\rm ind}^1$~$E_{\rm exch-ind}^1$~$E_{\rm disp}^1$~$E_{\rm exch-disp}^1$~$E_{\delta_{\rm HF}}^1$~$E_{\rm A}^1$~$E_{\rm B}^1$ \\
 $R^2$~$\beta_{\rm A}^2$~$\gamma_{\rm A}^2$~$\alpha_{\rm B}^2$~$\beta_{\rm B}^2$~$\gamma_{\rm B}^2$~$\phi_1^2$ ... $\phi_{N_{\rm ID}}^2$~$E_{\rm tot}^2$~$E_{\rm elst}^2$~$E_{\rm exch}^2$~$E_{\rm ind}^2$~$E_{\rm exch-ind}^2$~$E_{\rm disp}^2$~$E_{\rm exch-disp}^2$~$E_{\delta_{\rm HF}}^2$~$E_{\rm A}^2$~$E_{\rm B}^2$ \\
$\dots$
\noindent
\\

\begin{itemize}
\item $R^i$ is the center-of-mass separation between monomers in dimer $i$, given in angstroms.
\item $\beta_{\rm A}^i$, $\gamma_{\rm A}^i$, $\alpha_{\rm B}^i$, $\beta_{\rm B}^i$, and $\gamma_{\rm B}^i$ are the Euler angles for monomers A and B of dimer $i$ in the $zyz$ convention, given in degrees. The angle $\alpha_{\rm A}^i$ is always set to zero. See Ref.~\cite{Metz:16}, Sec.~II for more details.
\item $\phi_1^i$, ..., $\phi_{N_{\rm ID}}^i$ are the values of the $N_{\rm ID} = N_{\rm ID}^{\rm A} + N_{\rm ID}^{\rm B}$ internal degrees of freedom, where $N_{\rm ID}^{\rm A}$ and $N_{\rm ID}^{\rm B}$ are the numbers of internal degrees of freedom in monomers A and B, respectively. The $\phi_n^i$ values are ordered with those corresponding to IDOFs of monomer A first, and B second. In the current version of autoPES, the only internal degrees of freedom that are supported are chirality, and both $N_{\rm ID}^{\rm A}$ and $N_{\rm ID}^{\rm A}$ are equal to either 0 or 1. In the case of a homogeneous dimer with chiral monomers, the IDOF is used only for monomer A (without loss of generality). In the case of chirality, a value of $\phi_n^i = 0.0$ indicates no change from the undistorted input geometry, while a value of $\phi_n^i = 1.0$ indicates that the molecule is mirrored about its center of mass.
\item $E_{\rm tot}^i$ is the total intermolecular interaction energy of dimer $i$, given in kcal/mol.
\item $E_{\rm elst}^i$, $E_{\rm exch}^i$, $E_{\rm ind}^i$, $E_{\rm exch-ind}^i$, $E_{\rm disp}^i$, $E_{\rm exch-disp}^i$, and $E_{\delta_{\rm HF}}^i$ are the respective SAPT(DFT) energy components of dimer $i$, as described in the SAPT program manual \cite{SAPT2016}, given in kcal/mol.
\item $E_{\rm A}^i$~$E_{\rm B}^i$ are the total monomer energies of monomer A and B, respectively, given in Hartrees.
\end{itemize}

Note that depending on the {\em ab initio} method used, some energy components may be equal to zero. If the supermolecular method is used, all components except the total interaction energy and monomer energies are equal to zero.

The files {\tt NAME.geo} are created by the grid generation codes, and contain geometry coordinates in the same format as {\tt NAME.ener}, but do not contain energy values.

\item {\bf NAME.input\_long} -- The {\tt NAME.input\_long} file contains all the information of the {\tt NAME.input} file, plus some additional information, in a machine-friendly format. It is created by the {\tt make\_input2} program, and read in by various programs.

The format of the {\tt NAME.input\_long} file is given below.
\bigskip \\
\noindent
 $N_{\rm A}$~$N_{\rm ID,PHYS}^{\rm A}$~$N_{\rm ID,OA}^{\rm A}$~$q_{\rm A}$~$I_{\rm A}$~$p_{\rm A}$~$\alpha_{\rm A}$ \\
 $N_{\rm B}$~$N_{\rm ID,PHYS}^{\rm B}$~$N_{\rm ID,OA}^{\rm B}$~$q_{\rm B}$~$I_{\rm B}$~$p_{\rm B}$~$\alpha_{\rm B}$ \\
 $a_{1}$~$x_{A1}$~$y_{A1}$~$z_{A1}$~$q_{A1}$~$s_{A1}$~$t_{A1}$ \\
 $a_{2}$~$x_{A2}$~$y_{A2}$~$z_{A2}$~$q_{A2}$~$s_{A2}$~$t_{A2}$ \\
 $\dots$ \\
 $t_{\rm ID}^{A1}$~$v_{\rm ID}^{A1}$~$u_{\rm ID}^{A1}$~$n_{\rm ID}^{A1}$~$g_{\rm ID}^{A1}$~$k_{\rm ID}^{A1}$~$s_{\rm ID}^{A1,1}$ ... $s_{\rm ID}^{A1,n_{\rm ID}^{A1}}$ \\
 $t_{\rm ID}^{A2}$~$v_{\rm ID}^{A2}$~$u_{\rm ID}^{A2}$~$n_{\rm ID}^{A2}$~$g_{\rm ID}^{A2}$~$k_{\rm ID}^{A2}$~$s_{\rm ID}^{A2,1}$ ... $s_{\rm ID}^{A2,n_{\rm ID}^{A2}}$ \\
 $\dots$ \\
 $b_{1}$~$x_{B1}$~$y_{B1}$~$z_{B1}$~$q_{B1}$~$s_{B1}$~$t_{B1}$ \\
 $b_{2}$~$x_{B2}$~$y_{B2}$~$z_{B2}$~$q_{B2}$~$s_{B2}$~$t_{B2}$ \\
 $\dots$ \\
 $t_{\rm ID}^{B1}$~$v_{\rm ID}^{B1}$~$u_{\rm ID}^{B1}$~$n_{\rm ID}^{B1}$~$g_{\rm ID}^{B1}$~$k_{\rm ID}^{B1}$~$s_{\rm ID}^{B1,1}$ ... $s_{\rm ID}^{B1,n_{\rm ID}^{B1}}$ \\
 $t_{\rm ID}^{B2}$~$v_{\rm ID}^{B2}$~$u_{\rm ID}^{B2}$~$n_{\rm ID}^{B2}$~$g_{\rm ID}^{B2}$~$k_{\rm ID}^{B2}$~$s_{\rm ID}^{B2,1}$ ... $s_{\rm ID}^{B2,n_{\rm ID}^{B2}}$ \\
 $\dots$ \\
 $P_{\rm els}^1$~$P_{\rm pol}^1$~$P_{\rm i+d}^1$~$P_{\rm exp}^1$ \\
 $P_{\rm els}^2$~$P_{\rm pol}^2$~$P_{\rm i+d}^2$~$P_{\rm exp}^2$ \\
 $\dots$
\noindent
\\
\begin{itemize}

\item The first and second lines correspond to monomers A and B, respectively.
\begin{itemize}
\item $N_{\rm A}$ is the number of sites in monomer A.
\item $N_{\rm ID,PHYS}^{\rm A}$ is the number of physical IDOFs in monomer A (currently only chirality is supported).
\item $N_{\rm ID,OA}^{\rm A}$ is the number of off-atomic site IDOFs (not yet supported in the current version).
\item $q_{\rm A}$ is the charge of monomer A, given as an integer in atomic units.
\item $I_{\rm A}$ is the ionization potential of monomer A in units of electron volts.
\item $p_{\rm A}$ is the dipole moment of monomer A in units of Debye.
\item $\alpha_{\rm A}$ is the isotropic polarizability of monomer A in atomic units.
\end{itemize}
And similarly for monomer B.
\item The next $N_{\rm A}$ lines correspond to the sites of monomer A, with one line per site, in the same order as they appear in the {\tt NAME.input} file.
\begin{itemize}
\item $a_{i}$ is the site label, as given in the {\tt NAME.input} file.
\item $x_{i}$, $y_{i}$, and $z_{i}$ are site coordinates in bohrs.
\item $q_{i}$, $s_{i}$, and $t_{i}$ are the atomic number (zero for off-atomic sites), symmetry index, and guiding force-field type, respectively. They have the same meaning as in the {\tt NAME.input} file, described in Sec.~\ref{subsec:input}.
\end{itemize}
\item The next $N_{\rm ID}^{\rm A}$ lines correspond to the IDOFs of monomer A. In the current version of autoPES, the only implemented internal degree of freedom is monomer chirality.
\begin{itemize}
\item $t_{\rm ID}^{i}$ is the type of the IDOF $i$. A value of 1 indicates a linear IDOF, a value of 2 indicates an angular IDOF, and a value of 3 indicates a chiral IDOF.
\item The values $v_{\rm ID}^{i}$, $u_{\rm ID}^{i}$, $n_{\rm ID}^{i}$, $g_{\rm ID}^{i}$, $k_{\rm ID}^{i}$, and $s_{\rm ID}^{i,1}$ through $s_{\rm ID}^{i,n_{\rm ID}^{i}}$ are unused in the case of a chiral IDOF.
\end{itemize}
\item The next $N_{\rm B}$ lines correspond to the sites of monomer B, with one line per site, in the same order as they appear in the {\tt NAME.input} file. The variables have similar meanings as for monomer A.
\item The next $N_{\rm ID}^{\rm B}$ lines correspond to the IDOFs of monomer B. The variables have similar meanings as for monomer A.
\item The next section contains one line per site type, that is, the number of lines is equal to the largest $s_i$ value. The meanings of the variables $P_{\rm els}^i$, $P_{\rm pol}^i$, $P_{\rm i+d}^i$, and $P_{\rm exp}^i$ are the same as described in Sec.~\ref{subsec:input}.
\end{itemize}

\end{itemize}

\subsection{Programs and scripts in the autoPES suite}
\begin{itemize}
\item {\bf add\_geo}  -- FORTRAN 95 program which converts an XYZ dimer geometry file into the $R$ and Euler angle coordinates used by autoPES. Requires input arguments NAME, specifying the name of the system, GEO\_FILE, specifying the .xyz file (in the standard format), and MAX\_DIST, specifying a maximum closest-contact atom distance in angstroms that the program will consider a valid geometry (MAX\_DIST equal to zero indicates no maximum distance).
\begin{verbatim}
$PATH/add_geo NAME GEO_FILE MAX_DIST
\end{verbatim}
%
\item {\bf autoPES} -- FORTRAN 95 program which is the frond-end program for the autoPES package. It reads in the input file NAME.ctrl and calls the master.sh script. When called, it requires the NAME and optional MODE variables (see Sec.~\ref{subsec:runmodes}).
\begin{verbatim}
$PATH/autoPES NAME MODE
\end{verbatim}
%
\item {\bf clean\_failed.sh} -- Bash script which cleans all failed SAPT calculations from current directory.
\begin{verbatim}
$PATH/clean_failed.sh
\end{verbatim} 
%
\item {\bf combine\_ener} -- FORTRAN 95 program which combines results of SAPT(DFT) calculations and $\delta E^{\rm HF}_{\rm int,resp}$ calculations into a single file. Requires as inputs the names of the two files and a logical value INC\_DELTA indicating whether the delta-HF correction is included. If INC\_DELTA is set to `F', the program simply acts as a pass-through.
\begin{verbatim}
$PATH/combine_ener MAIN_ENER_FILE DELTAHF_ENER_FILE INC_DELTA
\end{verbatim}
%
\item {\bf eval\_pes} -- FORTRAN 95 program which evaluates a generated PES at a given geometry. Requires the fit parameter file and an XYZ dimer geometry file as input arguments. The XYZ file must be in the standard `.xyz' format, and have the atoms in the order that they appear in the {\tt NAME.input} file used to generate the parameter file, with monomer A first and monomer B second.
\begin{verbatim}
$PATH/eval_pes FF_FILE < geo.xyz
\end{verbatim}
%
\item {\bf extract\_ener} -- FORTRAN 95 program which extracts energies from {\em ab initio} output files and creates a {\tt NAME.ener} file. Required inputs are NAME, OUTPUT\_FILE, MODE (either `dft', `deltahf', `supmol', or `asym' depending on the type of OUTPUT\_FILE), and a logical value HYBRID (only used if MODE is `dft').
\begin{verbatim}
$PATH/extract_ener NAME OUTPUT_FILE MODE HYBRID
\end{verbatim}
%
\item {\bf find\_minima.sh} -- Bash script which finds local minima of the given PES. It creates input files, runs multiple instances of {\tt pesw\_ff} (described below) in parallel, collects outputs, then calls {\tt sort\_minima} to sort and filter the minima. Required arguments are NAME, BIN\_DIR (points to the autoPES/bin directory), FF\_FILE and FF\_TYPE (which specify the name and type of PES parameter file), and NPAR (which specifies the number of parallel instances of {\tt pesw\_ff} to run). Requires the files {\tt NAME.input\_long} and FF\_FILE and produces output file {\tt minima.dat}.
\begin{verbatim}
$PATH/find_minima.sh NAME BIN_DIR FF_FILE FF_TYPE NPAR
\end{verbatim}
%
\item {\bf fit\_asymp} -- FORTRAN 95 program which fits the distributed asymptotic expansion of the PES using an implementation of Powell's algorithm\cite{Praxis}. It requires {\tt NAME.input\_long} and {\tt NAME.ener} input files. It generates {\tt fit\_asymp.dat}, which is used as input for the main fitting program. Required arguments are NAME, COM\_RULE (1 = use geometric combination rules, 0 = site-pair specific parameters), MAX\_CN (maximum power in the induction plus dispersion expansion), and INC\_PEN (logical value indicating whether or not to use the dlDF penalty function).
\begin{verbatim}
$PATH/fit_asymp NAME COM_RULE_VDW MAX_CN INC_PEN
\end{verbatim}
%
\item {\bf fit\_inter} -- FORTRAN 95 program which performs the fitting of the intermolecular potential energy surface using an implementation of Powell's algorithm \cite{Praxis}. It requires as standard input a FORTRAN namelist file {\tt fit.in} specifying fit options. It reads in {\tt NAME.input\_long}, {\tt NAME.ener}, and {\tt fit\_asymp.dat}. It generates {\tt fit\_inter.dat}, which contains all optimized fit parameters. The available options in the {\tt fit.in} file are described in the comments of the {\tt fit\_inter.f90} file.
\begin{verbatim}
$PATH/fit_inter NAME < fit.in
\end{verbatim}
%
\item {\bf gen\_report} -- FORTRAN 95 program which generates a human-readable report file containing important information about the fit. Requires as input NAME, FF\_FILE and FF\_TYPE specifying a parameter input file and type, optional MINIMA\_FILE containing local minima of the PES, the four combination rules used, and four values giving information about the repulsive wall: MIN\_WALL\_HEIGHT, MEAN\_WALL\_HEIGHT, MIN\_WALL\_DIST, and MAX\_WALL\_DIST.
\begin{verbatim}
$PATH/gen_report NAME FF_FILE FF_TYPE MINIMA_FILE
          COM_RULE_EXP COM_RULE_DMP COM_RULE_LIN COM_RULE_VDW
          MIN_WALL_HEIGHT MEAN_WALL_HEIGHT MIN_WALL_DIST MAX_WALL_DIST
\end{verbatim}
%
\item {\bf gridgen\_ff} -- FORTRAN 95 program which generates the main set of grid points for the {\em ab initio} calculations. Requires the following variables: NAME, NGRID (number of points to generate), FF\_FILE (file containing the force field parameters), FF\_TYPE (1 for initial guiding potential or 2 for generated potential), GRID\_WEIGHT\_SCALE. If the file {\tt NAME.ener} exists, it will be used to define pre-existing grid points. Creates the output file {\tt NAME.geo\_main}.
\begin{verbatim}
$PATH/gridgen_ff NAME NGRID FF_FILE FF_TYPE GRID_WEIGHT_SCALE
\end{verbatim}
%
\item {\bf get\_nfreeparm} -- FORTRAN 95 program which determines the number of free parameters in the final stage of fitting of the complete intermolecular PES.
\begin{verbatim}
$PATH/get_nfreeparm NAME COM_RULE_EXP COM_RULE_LIN POLY_ORDER
\end{verbatim}
%
\item {\bf gridgen\_min}  -- FORTRAN 95 program which generates grid points around the local minima. As input it reads a previously generated text file with the coordinates of the minima. As output, a file {\tt NAME.geo\_min} is produced, which contains grid points for the subsequent {\em ab initio} calculations. Requires input arguments NAME, MINIMA\_FILE (a file containing minima coordinates), and NPOINT (the number of grid points to add).
\begin{verbatim}
$PATH/gridgen_min NAME MINIMA_FILE NPOINT
\end{verbatim}
%
\item {\bf hole\_scan} -- FORTRAN 95 program which scans for holes in the repulsive wall of the generated PES. Requires input variables NAME, FF\_FILE (containing fit parameters), FF\_TYPE (usually 2), WALL\_HEIGHT, MIN\_ENERGY (value of PES global minimum), and WALL\_MIN\_DIST.
\begin{verbatim}
$PATH/hole_scan NAME FF_FILE FF_TYPE WALL_HEIGHT MIN_ENERGY
      WALL_MIN_DIST
\end{verbatim}
%
\item {\bf make\_asym\_grid} -- FORTRAN 95 program, which creates a {\tt NAME.ener} for the asymptotic calculations. It requires input arguments NAME and DISTR.
\begin{verbatim}
$PATH/make_asym_grid NAME DISTR
\end{verbatim}
%
\item {\bf make\_dalt\_inp} -- FORTRAN 95 program, which creates DALTON inputs (*.mol and *.dal) to be used in the asymptotic SAPT calculations. Additionally this program creates input NAMEP.data and NAME.dispinp files for the asymptotic SAPT program. Requires input arguments NAME, BINDIR (location of the directory with the autoPES executables), basis set name, HYBRID, MODE (set to `asymp', `distr', or `deltahf'), and MAX\_MEM (memory for SAPT programs in words).
\begin{verbatim}
$PATH/make_dalt_inp NAME BINDIR BASIS HYBRID MODE MAX_MEM
\end{verbatim}
%
\item {\bf make\_dlpoly\_inp} -- FORTRAN 95 program, which generates the FIELD and TABLE input files for DL\_POLY. It requires the following variables: NAME, FF\_FILE (PES parameter file), R\_CUTOFF (DL\_POLY potential cutoff radius).
\begin{verbatim}
$PATH/make_dlpoly_inp NAME FF_FILE R_CUTOFF
\end{verbatim}
%
\item {\bf make\_input2} -- FORTRAN 95 program which takes user-supplied input files {\tt NAME.input} and {\tt NAME.ctrl} and generates {\tt NAME.input\_long}, which is used by most other programs. Requires as input NAME. Optional inputs are IP\_FILE (a file containing monomer ionization potentials), DM\_FILE (a file containing monomer dipole moments), PZ\_FILE (a file containing monomer isotropic polarizabilities). If the optional input files are not provided, values of zero are used.
\begin{verbatim}
$PATH/make_input2 NAME IP_FILE DM_FILE PZ_FILE
\end{verbatim}
%
\item {\bf make\_ip\_inp} -- FORTRAN 95 program, which creates ORCA inputs for the ionization potential and isotropic polarizability calculations. It requires the following variables: NAME, BASIS, POLARIZABLE (whether the induced dipole model is used)
\begin{verbatim}
$PATH/make_ip_inp NAME BASIS POLARIZABLE
\end{verbatim}
%
\item {\bf make\_orca\_inp} -- FORTRAN 95 program, which creates the input files for the {\em ab initio} calculations with ORCA front-end. Files created by this program are: {\tt NAMEMA.data}, {\tt NAMEMB.data}, {\tt NAMEA.data}, {\tt NAMEB.data}, {\tt NAMEP.data}, {\tt NAME.aux}. When called as a stand alone program, it requires values of the following variables: NAME, SAME, BINDIR ({\tt bin} directory of the autoPES package), BASIS, HYBRID (whether hybrid functional is used), MODE (set to `dft', `deltahf', or `distr'), MB\_CUTOFF, NCORES\_SAPT, and MAX\_MEM (memory for SAPT programs in words).
\begin{verbatim}
$PATH/make_orca_inp NAME BINDIR BASIS HYBRID MODE MB_CUTOFF NCORES_SAPT MAX_MEM
\end{verbatim}
%
\item {\bf make\_pesw\_inp} -- FORTRAN 95 program, which prepares input files for the {\tt pesw\_ff} program. It requires input variables NAME, NCORES, and NSTART (the number of starting configurations for the minima search).
\begin{verbatim}
$PATH/make_pesw_inp NAME NCORES NSTART
\end{verbatim}
%
\item {\bf master.sh} -- Bash script, which is the main script for the autoPES suite. It is called by the {\tt autoPES} front-end program and subsequently calls all other program and scripts. It requires as inputs all options read in from {\tt NAME.ctrl} (or defaults).
%
\item {\bf pesw\_ff} -- FORTRAN 77 program which searches for the local minima of the PES. This program requires three input files {\tt cluster.dat}, {\tt control.dat} and {\tt coords.dat}, which are created by the {\tt make\_pesw\_inp} program. Reads the input file {\tt NAME.input\_long} and produces results through standard output. Requires the input arguments NAME, FF\_FILE, and FF\_TYPE.
\begin{verbatim}
$PATH/pesw_ff NAME FF_FILE FF_TYPE
\end{verbatim}
%
\item {\bf slave\_asym.sh} -- Bash script which perform the asymptotic calculations and asymptotic fit. It is called by the {\tt master.sh} script and requires the logical input WAIT, indicating whether the script should return immediately after submitting jobs (allowing the {\tt master.sh} script to move to other parts of PES generation) or wait until job completion
\begin{verbatim}
$PATH/slave_asym.sh WAIT
\end{verbatim} 
%
\item {\bf slave\_fit.sh} -- Bash script which performs complete PES fitting and hole scanning. It requires input INC\_TEST\_SET (whether to use a test data set).
\begin{verbatim}
$PATH/slave_fit.sh INC_TEST_SET
\end{verbatim}
%
\item {\bf slave\_gridgen.sh} -- Bash script which performs the grid generation. It is called by the {\tt master.sh} script and requires input FF\_TYPE
\begin{verbatim}
$PATH/slave_gridgen.sh FF_TYPE
\end{verbatim}
%
\item {\bf slave\_ip.sh} -- Bash script which performs ionization potential and isotropic polarizability calculations using ORCA.
\begin{verbatim}
$PATH/slave_ip.sh
\end{verbatim} 
%
\item {\bf slave\_sapt.sh} -- Bash script which performs SAPT calculations.
\begin{verbatim}
$PATH/slave_sapt.sh
\end{verbatim}
%
\item {\bf submit.sh} -- Bash script which takes input arguments which provide information about some computationally intensive work to be performed, and performs that work. This must be modified to work with a given computer system as part of the autoPES installation process. Generally this will interface with the job queuing mechanism on a given computer system. See the example file {\tt submit.sh.EXAMPLE} for details.
\begin{verbatim}
$PATH/submit.sh RUN_MODE NAME JOBNAME INFILES OUTFILES WORK NCORES_PER
      NCORES_TOT
\end{verbatim}
%
\item {\bf sort\_minima} -- FORTRAN 95 program which filters and sorts minima of the PES found by {\tt pesw\_ff}. As an input, it reads a previously generated text file with the coordinates of the minima. The standard output is a sorted list of local minima. Requires input arguments NAME, MINIMA\_FILE (a file containing minima coordinates), FF\_FILE (containing fit parameters), and FF\_TYPE (1 = initial guiding potential, 2 = generated potential).
\begin{verbatim}
$PATH/sort_minima NAME MINIMA_FILE FF_FILE FF_TYPE
\end{verbatim}
%
\item {\bf toxyz} -- FORTRAN 95 program which converts the $R$ and Euler angle coordinates used by autoPES to Cartesian coordinates. {\tt toxyz} requires as input the name of the system, and must be run from a directory containing the {\tt NAME.input\_long} file. Standard input is a space-separated list of coordinates as they appear on a single line of a {\tt NAME.ener} file.
\begin{verbatim}
$PATH/toxyz NAME < coors.dat
\end{verbatim}
\end{itemize}

\newpage
\bibliography{references}

\end{document}